#!/bin/zsh

set -x -v

PACKAGEDIR="$PWD"
PRODUCT="F-Script Anywhere"

cd "$PACKAGEDIR"/Source && \
source VERSION.xcconfig && \
find . -name \*~\* -exec rm -r '{}' \; && \
VERSION=${CURRENT_MARKETING_VERSION} && \
DMG="$PRODUCT-$VERSION.dmg" VOL="$PRODUCT $VERSION" && \
DSTROOT="$PACKAGEDIR/$VOL" && \
sudo rm -rf "$DSTROOT" && \
sudo rm -rf build/ && \
rm -rf build/ && \
xcodebuild -target "Application" -configuration Deployment "DSTROOT=$DSTROOT" DEPLOYMENT_LOCATION=YES install && \
mkdir "$DSTROOT" && \
# ditto -rsrc "$PACKAGEDIR"/Source "$DSTROOT"/Source && \
# rm -rf "$DSTROOT"/Source/build && \
find "$DSTROOT" -name ".svn" -exec sudo /bin/rm -rf "{}" \; ; \
cd "$PACKAGEDIR" && \
rm -f "$DMG" && \
hdiutil create "$DMG" -megabytes 10 -ov -layout NONE -fs 'HFS+' -volname "$VOL" && \
MOUNT=`hdiutil attach "$DMG"` && \
DISK=`echo "$MOUNT" | sed -ne ' s|^/dev/\([^ ]*\).*$|\1|p'` && \
MOUNTPOINT=`echo "$MOUNT" | sed -ne 's|^.*\(/Volumes/.*\)$|\1|p'` && \
ditto -rsrc "$DSTROOT" "$MOUNTPOINT" && \
sudo chmod -R a+rX,u+w "$MOUNTPOINT" && \
# openUp "$MOUNTPOINT" && \
hdiutil detach $DISK && \
hdiutil convert "$DMG" -format UDZO -imagekey zlib-level=9 -o "z$DMG" && \
mv "z$DMG" "$DMG" && \
hdiutil internet-enable "$DMG" && \
scp "$DMG" ainaz:web/nriley/software/
